<!doctype html public "-//w3c//dtd html 3.2//en">

<html>

<head>
<title>Devoir de compilation</title>
<meta name="GENERATOR" content="Arachnophilia 4.0">
<meta name="FORMATTER" content="Arachnophilia 4.0">
<style>
h1 {color: #F00000; font-size: 24pt; align: center}
em {color: #800000; font-weight: bold}
tt {color: #000080; font-family: courier; font-weight: bold}
pre {color: #000080; font-family: courier; font-weight: bold}
.br {border-style: groove;
       border-color: red; border-width: 5px}
</style>
</head>

<body bgcolor="#ffffB0" text="#000000" link="#0000ff" 
   vlink="#800080" alink="#ff0000">

<h1><img src="devlog.gif" width="587" height="124" alt=""></h1>

<p>
<h2><font color=#007000>(Novembre 2000)</font></h2><p>

<font size="+1">
Vous allez écrire un convertisseur de syntaxe qui lit un programme dans un langage proche du Haskell (opérateurs infixes, filtrage des paramètres, reconnaissance du <em>layout</em> (indentation, etc.), et qui génère un programme en format Scheme (notation préfixe + parenthésage, formes <tt>define</tt> et <tt>let</tt> spécifiques à ce langage, séquences, etc.) <p>

<span class="br">Un exemple :</span><p>
<a name="vers"> </a>
<pre>
reverse [] = []
reverse (x:q) = reverse q ++ [x]
</pre>
doit être transformé en (plus ou moins) : <p>
<pre>
(define (reverse arg1)
  (if (= arg1 ()) ()
      (append (reverse (cdr arg1)) (list (car arg1)))))
</pre>
mais attention, cet exemple et les autres sont uniquement pour vous guider, et ne constituent en aucun cas ni les contraintes imposées sur le style, ni même des suggestions ! Au lieu de <tt>if</tt> vous pourrez utiliser <tt>cond</tt>. Les paramètres filtrés pourront d'abord être nommés, etc. Voici une autre version :

<pre>
(define (reverse arg1)
  (let ((x (car arg1))
        (q (cdr arg1)))
    (cond ((null arg1) ())
          (else (append (reverse q) (cons x ()))))))
</pre>
Donc, votre "compilateur" est en fait un parseur, avec un "générateur de code" plutôt simpliste, qui produit un fichier textuel contenant le programme en Scheme. L'analyse sémantique sera pratiquement absente ou très réduite.

<p>

<center><img src="barre.jpg" width="500" height="12" alt=""></center>
<p>



<span class="br">Détails administratifs :</span><p>
<ul>
 <li> <i><b>Langage de construction</b></i> : Haskell. Votre programme doit de préférence tourner sous Hugs, mais si quelqu'un préfère un autre système de compilation (GHC, NHC), allez-y. Le code-cible doit être acceptée par un un système Scheme standard, par exemple par DrScheme. <p>
<i><b>Variante acceptable également :</b></i> <em>Écrivez le parseur directement en Scheme</em>. Vous serez alors obligés de convertir les outils de parsing proposés en cours en Scheme, mais le "générateur du code" disparaîtra complètement, car il suffira d'utiliser la commande d'affichage standard en Scheme (ou même tester le résultat sur place). <p>

 <li> <i><b>Forme</b></i> (tous les éléments ci-dessous sont obligatoires) : 
  <ol>
          <li> Un rapport écrit <b>ou</b> (le choix est à vous !) un document électronique en format PDF, PostScript ou une collection de pages HTML. Autres formats (p. ex. format natif de Star Office) à négocier. <i>Désolé, mais je n'accepte pas les documents en format MS Word</i>.
          <li> <em>Au moins</em> 6 exemples de conversion relativement riches et différents. Les exemples doivent couvrir les traitements habituels des listes, un peu du numérique, les extensions impératives (<tt>set</tt>), fonctions d'ordre supéreieur, etc. Longueur typique d'une procédure convertie (d'un exemple concret typique) : 10 lignes. 

          <li> L'accès à la source de votre programme et aux sources des exemples. Je veux pouvoir vérifier comment il marche, et je ferai cela aléatoirement. Si le programme ne fonctionne pas comme spécifié dans le rapport, ou si les fichiers ne sont pas accessibles <i>via</i> Web, ou si les informations sur le programme me parviennent trop tard, la pénalisation sera sévère. Je souligne : les programmes <em>peuvent</em> être fautifs ou incomplets. Un tel travail ne sera jamais parfait. Mais les défaillances doivent être répertoriées. Je pénalise sourtout la négligence !
  </ol> <p>

 <li> <i><b>Deadline</b></i> : dates publiées par Hamid Rahbar. Une prolongation est possible, mais le devoir doit être rendu (et corrigé) avant la fin du semestre. <p>

 <li> Si vous avez des questions, doutes, etc., si vous avez des difficultés, n'attendez pas, <a href="mailto:karczma@info.unicaen.fr">envoyez-moi un e-mail immédiatemment.</a>
</ul>

<center><img src="barre.jpg" width="500" height="12" alt=""></center>
<p>

<span class="br">Commentaires et détails :</span><p>

Votre convertisseur <em>doit</em> être un peu plus intelligent qu'un simple 
parseur qui transforme un texte avec opérateurs en arbre, et ensuite imprime 
cet arbre sous forme d'une liste de listes. <i><b>Mais il ne s'agit en aucun 
cas de construire un translateur de Haskell !</b></i> (Par exemple, de 
reconnaître les applications partielles. Si on définit en Haskell 
<tt>f x y = g (x,y)</tt>, et ensuite on utilise dans le programme 
<tt>(f x)</tt>, ceci est équivalent à <tt>\y -&gt; f x y</tt>, ce 
qui serait converti en <tt>(lambda (y) (f x y))</tt>. On ignorera ces 
problèmes, comme on ignorera les "sections" des opérateurs : <tt>(x *)</tt> etc.) 
Bien sûr, votre compilateur ignorera le typage.
<p>

Par contre, voici quelques problèmes qui doivent obligatoirement être traités :
<ol>
  <li> Les occurrences multiples des opérateurs <tt>+</tt> et <tt>*</tt> doivent être 
  réduites : <tt>a+b+c*d*e+f</tt> doit se transformer en <tt>(+ a b (* c d e) f)</tt>.
<p>

  <li> Tous les opérateurs standard, comme les ops. arithmétiques et relationnels : 
  <tt>(&lt;), (&gt;), (==), (!=)</tt> doivent être reconnus, comme les opérateurs 
  <tt>(:), (++)</tt>, etc. 
<p>

La possibilité de reconnaître d'autres opérateurs, y compris ceux définis par 
l'utilisateur est optionnelle, mais suggérée. 
<p>

  <li> Le minimum du <em>layout</em> doit être pris en compte. Le programme
       ne doit pas confondre
       <pre>
 ... let f x = g a b c d
          h m n = p q
       </pre>
       et
       <pre>
 ... let f x = g a b c
         d h m n = p q
       </pre>
       <p>

  <li> Les structures de contrôle classiques : <tt>if_then_else</tt>, <tt>case</tt>,
      et les définitions internes (<tt>let</tt>, <tt>where</tt>). <p>

  <li> Scheme, étant un langage "impur" (possédant des constructions impératives) <em>exige</em> la possibilité d'écrire des séquences d'instructions. On peut facilement inventer un opérateur <tt>set</tt> utilisé comme suit : <tt>set x ff</tt>, ce qui sera traduit en <tt>(set! x ff)</tt>, et prévoir les opérateurs qui s'appellent en code source : <tt>set_car</tt> et <tt>set_cdr</tt> traduits en <tt>set-car!</tt> et <tt>set-cdr!</tt>, mais la sérialisation, par exemple <tt>(begin a b c d)</tt>, ou
<pre>
(let ((x p) (y q))
  a
  b
  c d)
</pre>
est plus délicate. <i><b>Le langage source définira un opérateur infixe :</b></i> <tt>$&gt;</tt> qui réalisera le <tt>begin</tt> (et qui pourra être simplifié dans <tt>let</tt>). Les sources des expressions ci-dessus seraient :
<pre>
a $&gt; b $&gt; c $&gt; d

let x=p
    y=q
in  a $&gt; b $&gt; c $&gt; d
</pre>
<p>

<li> Finalement, la partie la plus sérieuse : clauses multiples et filtrage des paramètres, comme sur <a href="#vers">l'exemple ci-dessus</a>. Notez qu'il faudra peut-être inventer des noms pour des paramètres ! Sans types utilisateur le système doit pouvoir filtrer les listes (l'opérateur <tt>(:)</tt> et les formes <tt>[a,b,c]</tt>), ainsi que les tuples : <tt>(a,b,c)</tt>. Mais il doit également traiter correctement les clauses qui filtrent les constantes :
<pre>
fnct 0 = blahBlah
fnct n = etEncore          -- quand n&gt;0
</pre>
En fait, vous allez écrire une partie d'une procédure d'<em>unification</em>, et une maîtrise du Prolog peut ici vous être utile.
<p>

  <li> Le devoir reste assez souple. Vous pouvez définir les opérateurs, vous pouvez traiter le <em>layout</em> (l'indentation) de manière plus ou moins sérieuse. Votre programe peut être riche ou minimaliste. L'approche minimaliste résultera évidemment en note minimaliste aussi...

</ol>
<p>

<i><b>Lisez la documentation du Haskell concernant la lecture et l'écriture des fichiers. Ceci sera abordé en cours, mais sans détails.
</b></i>
<p>


<span class="br">Éléments optionnels :</span><p>

<ul>
 <li> Définition et usage des structures de données (transformées en Scheme en objets de type <tt>struct</tt> et construits par <tt>define-struct</tt>), et définies en programme-source comme les définitions <tt>data</tt> en Haskell.
</ul>

</font>

</body>

</html>
